// DefenseTurret server-status query script/gui
$dtquery_map=0;

package dtquery {
	function OptionsDlg::onWake(%this) {

		if (!$dtquery_map) {
			$RemapName[$RemapCount]="\c3DefenseTurret Query";
			$RemapCmd[$RemapCount]="dt_doquery";
			$RemapCount++;
			$dtquery_map=1;
		}
		parent::onWake(%this);
	}
};

if (!isActivePackage(dtquery))
		activatepackage(dtquery);

function dt_doquery(%val) {
	if (%val) {
		commandtoserver('GetDTStatus');
	} else {
		commandtoserver('StopDTStatus');
	}
}

function handleDTStartStatus(%msgt, %msg, %version, %optional, %requiredintourney, %maxwpt_height) {
		canvas.pushdialog(dt);
		%t=   "<tab:125,325>Server version\t:" 	@ %version;
		%t=%t@"\n<tab:125,325>Optional\t:" 			@ (%optional ? "Yes" : "No");
		%t=%t@"\n<tab:125,325>Required in Tourney\t:" 			@ (%requiredintourney ? "Yes" : "No");
		%t=%t@"\n<tab:125,325>Waypoint height\t:" 			@ %maxwpt_height;
		%t=%t@"\n";
		$dt_statdata=%t;
		$dt_statcount=0;
}


function handleDTClientStatus(%msgt, %msg, %client, %clientstatus, %clientteam) {
		$dt_statcount++;
		if ($dt_statcount==1) 
			%nl="\n<tab:125,225,325>";

		switch (%clientstatus) 
		{
			case -3	: %stat="<spush><color:CCFFAA>[BOT]<spop>";
			case -1	: %stat="<spush><color:FFCCAA>[nodt]<spop>";
			case 0 	: %stat="<spush><color:FF0000>[DT-]<spop>";
			case 1 	: %stat="<spush><color:CCFFAA>[DT+]<spop>";
			default	: %stat="<spush><color:FFCCAA>[WTF?]<spop>";

		}


		$dt_statdata=$dt_statdata 
			@ %nl
			@ $PlayerList[%client].name @ %stat
			@ "\t";

		if ($dt_statcount==4) 
			$dt_statcount=0;
			
		// add status to PlayerList too, for convenience
		$PlayerList[%client].dtstatus=%clientstatus;
}

function handleDTEndStatus(%msgt, %msg) {
		dtstatus.settext($dt_statdata);
}

function handleDTHideStatus(%msgt, %msg) {
		canvas.popdialog(dt);dtstatus.settext("");
}

addMessageCallback('MsgDTStartStatus',handleDTStartStatus);
addMessageCallback('MsgDTClientStatus',handleDTClientStatus);
addMessageCallback('MsgDTEndStatus',handleDTEndStatus);
addMessageCallback('MsgDTHideStatus',handleDTHideStatus);

new GuiControl(dt) {			
	profile = "GuiDialogProfile";			
	horizSizing = "width";			
	vertSizing = "height";			
	position = "0 0";			
	extent = "640 480";			
	minExtent = "8 8";			
	visible = "1";			
	hideCursor = "0";			
	bypassHideCursor = "1";			
	new ShellPaneCtrl(dtpane) {			
		profile = "ShellPaneProfile";			
		horizSizing = "center";			
		vertSizing = "center";			
		position = "0 0";			
		extent = "557 330";			
		minExtent = "48 92";			
		visible = "1";			
		hideCursor = "0";			
		bypassHideCursor = "0";			
		helpTag = "0";			
		text = "DefenseTurret Status";			
		longTextBuffer = "0";			
		maxLength = "255";			
		noTitleBar = "0";			
		new GuiMLTextCtrl(dtstatus) {			
			profile = "GuiDefaultProfile";			
			horizSizing = "right";			
			vertSizing = "bottom";			
			position = "53 39";			
			extent = "453 257";			
			minExtent = "8 8";			
			visible = "1";			
			hideCursor = "0";			
			bypassHideCursor = "0";			
			helpTag = "0";			
			lineSpacing = "2";			
			allowColorChars = "1";			
			maxChars = "-1";			
			deniedSound = "InputDeniedSound";			
		};			
	};			
};			

